package com.openfog.mqtttest;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends Activity {
	
	public TextView resultText;
	
	public String server;
	String topic = "myalarm/s1";
	String payload = null;
	
	public int checkPressFlag = 0;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		final EditText serverEditText = (EditText)findViewById(R.id.serverText);
		final Button SWOn = (Button)findViewById(R.id.sendButtonOn);
		final Button SWOff = (Button)findViewById(R.id.buttonOff);
		
		final Button SWLock = (Button)findViewById(R.id.buttonLock);
		final Button SWUnlock = (Button)findViewById(R.id.buttonUnlock);
		
		final CheckBox chkBoxSiren = (CheckBox)findViewById(R.id.checkBoxSiren);
		
		resultText = (TextView)findViewById(R.id.resultTextView);
		
		server = serverEditText.getText().toString();
		
		if (MQTTUtils.connect(server,topic)) {
			serverEditText.setEnabled(false);
			SWOn.setEnabled(true);
			SWOff.setEnabled(true);
			SWLock.setEnabled(true);
			SWUnlock.setEnabled(true);
			chkBoxSiren.setEnabled(true);
			
			resultText.setText("Connected to the server.");
		} else {
			resultText.setText("Error connecting the server.");
		}
		
		SWOn.setOnClickListener(new OnClickListener() {
			
			@SuppressLint("NewApi")
			@Override
			public void onClick(View arg0) {

				payload = "$MQTTY=ONL1*";
				MQTTUtils.pub(topic, payload);		
				
			}
		});
		

		SWOff.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				payload = "$MQTTY=OFL1*";
				MQTTUtils.pub(topic, payload);
				
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}		//Wait For Send Finish for Prevent Bug
				
			}
		});
		
		SWLock.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				payload = "$MQTTYSCLOCK*";
				MQTTUtils.pub(topic, payload);
				
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
		});
		
		
		SWUnlock.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				payload = "$MQTTYUNLOCK*";
				MQTTUtils.pub(topic, payload);
				
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
		});
			
		chkBoxSiren.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				if(checkPressFlag == 0)
				{
					chkBoxSiren.setChecked(true);
					
					payload = "$MQTTYSIREN1*";
					MQTTUtils.pub(topic, payload);
				}
				else if(checkPressFlag == 1)
				{
					chkBoxSiren.setChecked(false);
					
					payload = "$MQTTYSIREN0*";
					MQTTUtils.pub(topic, payload);
				}
				else if(checkPressFlag == 2)
				{
					chkBoxSiren.setChecked(true);
					checkPressFlag = 0;
					
					payload = "$MQTTYSIREN1*";
					MQTTUtils.pub(topic, payload);
				}
				
				checkPressFlag++;
				
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
		});
	}
	
	
	@Override
	public void onResume(){
	    super.onResume();
	    // put your code here...
	    
		if (MQTTUtils.connect(server,topic)) {
			resultText.setText("Connected to the server.");
		} else {
			resultText.setText("Error connecting the server.");
		}

	}


	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
}
